
/******************************************************************************

Copyright (c) 1997, Andrew J. Weber, Jason P. Weber

Copyright information should have been included with this distribution
and may be found at ../meta/COPYRIGHT or obtained via email from weber@acm.org

******************************************************************************/

#include <bld/state.h>

/***********************************************************************
class BLD_State
***********************************************************************/
void BLD_State::SetLastBuilt(void)
{
	lastBuilt.GetFromClock();
	flags = flags | BLD_STATE_HAS_TIMESTAMP;
}

void BLD_State::SetLastBuilt(const GPL_Time & t)
{
	if (BLD_STATE_HAS_TIMESTAMP != (flags | BLD_STATE_HAS_TIMESTAMP) ||
		lastBuilt < t)
	{
		lastBuilt = t;
		flags = flags | BLD_STATE_HAS_TIMESTAMP;
	}
}

GPL_Boolean BLD_State::Print(GPL_String & string,
								const GPL_Verbosity verbosity) const
{
	GPL_String image = "";
	if (BLD_STATE_HAS_TIMESTAMP & flags)
	{
		image.Join(",", "HAS_TIMESTAMP");
	}
	if (BLD_STATE_CHECKED & flags)
	{
		image.Join(",", "CHECKED");
	}
	if (BLD_STATE_EXECUTED_COMMANDS & flags)
	{
		image.Join(",", "EXECUTED_COMMANDS");
	}
	if (BLD_STATE_BUILD_FAILED & flags)
	{
		image.Join(",", "BUILD_FAILED");
	}
	image.Prepend("[");
	image.Append("]");
	image.Join(",", lastBuilt.ToString());

	string.Append(image);
	return TRUE;
}

GPL_Boolean BLD_State::Parse(const GPL_String & string)
{
	return FALSE;
}

