#ifndef SPA_BLENC_H
#define SPA_BLENC_H

/******************************************************************************

Coral Tree spa/blenc.h
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <spa/encrypt.h>

/******************************************************************************
class SPA_BlockEncrypter
******************************************************************************/
class SPA_BlockEncrypter : public SPA_Encrypter
{
	public:
		SPA_BlockEncrypter(void);
		virtual ~SPA_BlockEncrypter(void);

		virtual GPL_Boolean Encrypt(const GPL_Block & key, GPL_Block & data);
		virtual GPL_Boolean Decrypt(const GPL_Block & key, GPL_Block & data);
		/* Some compilers (Sun) seem to have trouble with derived just some */
		/* of an overloaded virtual; So:                                    */
		virtual GPL_Boolean Encrypt(GPL_Block & data)
			{ return SPA_Encrypter::Encrypt(data); }
		virtual GPL_Boolean Decrypt(GPL_Block & data)
			{ return SPA_Encrypter::Decrypt(data); }

		// GPL_Object
		GPL_OBJECT_INTERFACE(SPA_BlockEncrypter);
};

#endif /* SPA_BLENC_H */
