/******************************************************************************

Coral Tree spa/random.cc
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <osd/osd.h>
#include <spa/random.h>

/******************************************************************************
class SPA_Randomizer
******************************************************************************/
SPA_Randomizer::SPA_Randomizer(void)
{
	srand((unsigned int) osdTimer());
}

SPA_Randomizer::SPA_Randomizer(const unsigned long seed)
{
	srand((unsigned int) seed);
}

SPA_Randomizer::~SPA_Randomizer(void)
{
}

unsigned long SPA_Randomizer::RandomNumber(const unsigned long lower,
											const unsigned long upper) const
{
	if (0xFFFFFFFF > (upper - lower))
	{
	 	return lower + (rand() % (1 + (upper - lower)));
	}
	return rand();
}
